/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */
#include "nAPIConnectionListener.h"

#include <string>
#include <map>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nRealmACLEntry;
class nConnectionDetails;
class nACL;
class nLeafNode;
class nRealmNode;

namespace apps {

using namespace com::pcbsys::nirvana::nAdminAPI;
using namespace com::pcbsys::foundation::fbase;
using namespace Poco;

class connectionwatch;

class nChannelWatch : public nAPIConnectionListener {
  private:
    nLeafNode *m_pChannel;
    connectionwatch *m_pWatcher;

  public:
    nChannelWatch(nLeafNode *pChan, connectionwatch *pWatch);
    virtual void add(nConnectionDetails *pDetails);
    virtual void del(nConnectionDetails *pDetails);
};

class nRealmWatch : public nAPIConnectionListener {
  private:
    connectionwatch *m_pWatcher;

  public:
    nRealmWatch(connectionwatch *pWatch);
    virtual void add(nConnectionDetails *pDetails);
    virtual void del(nConnectionDetails *pDetails);
};

}
}
}
}
}
