/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */
#include "Observer.h"
#include "fSortedList.h"

#include "Poco/Mutex.h"

#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nNode;
class nRealmNode;
class nConnectionDetails;

namespace apps {

using namespace com::pcbsys::foundation::fbase;
using namespace com::pcbsys::foundation::collections;
using namespace Poco;

class connectionwatch : public Observer {
  public:
    connectionwatch(int argc, char** argv);

    virtual void update(Observable *pObs, void *pObj);

  private:
    void processArgs(int argc, char** argv);
    virtual void getOptions(int argc, char** argv);
    void registerNode(nRealmNode *pNode);
    void registerNodes(fSortedList<std::string, nNode*> nodes);
    static void Usage();
    void newConnection(const std::string& target, nConnectionDetails *pCd);
    void delConnection(const std::string& target, nConnectionDetails *pCd);

    std::string m_realmUrl;
    Mutex m_newConnectionMutex;

    friend class nChannelWatch;
    friend class nServiceWatch;
    friend class nRealmWatch;
};

}
}
}
}
}
