/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */

#include "fSortedList.h"
#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nNode;
class nRealmNode;
class nContainer;
class nLeafNode;
class nACL;
class nACLEntry;
class nChannelACLEntry;
class nRealmACLEntry;

namespace apps {

using namespace com::pcbsys::foundation::collections;

class nDumpACL {
  private:
    std::string m_realmUrl;

  public:
    nDumpACL(int argc, char** argv);

  private:
    virtual void getOptions(int argc, char** argv);
    static void Usage();
    void dumpACL(nRealmNode *pNode);
    void dumpACL(nContainer *pNode);
    void dumpACL(nLeafNode *pNode);
    void dumpACL(fSortedList<std::string, nACLEntry*>& entries);
    void dumpACL(fSortedList<std::string, nNode*>& nodes);
    void dumpACL(nACL *pAcl);
    void dumpACL(nChannelACLEntry *pEntry);
    void dumpACL(nRealmACLEntry *pEntry);
    void dumpBase(nACLEntry *pEntry);
};

}
}
}
}
}
