/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */
#pragma once

#include "nReconnectHandler.h"
#include "nAsyncExceptionListener.h"
#include "Exception.h"
#include <string>
#include <cstdlib>
#include <stdio.h>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace client {
class nSession;
class nBaseClientException;
class nSessionAttributes;
class nEventProperties;
class nEventAttributes;
class nDataStreamListener;
class nDataStream;
}
namespace apps {

using namespace client;

class nSampleApp :
    public nReconnectHandler, public nAsyncExceptionListener {
  public:
    nSampleApp(void);
    virtual ~nSampleApp(void);

    void disconnected(nSession *pSession);
    void reconnected(nSession *pSession);
    bool tryAgain(nSession *pSession);
    void handleException(nBaseClientException *pEx);

  protected:
    static void UsageEnv();
    static void processEnvironmentVariables();
    static std::string* parseRealmProperties(std::string& realmdetails, int& nURL);
    void constructSession(std::string *pRealmDetails, int nRealmDetail);
    void constructSession(std::string *pRealmDetails, int nRealmDetail, nDataStreamListener *pListener);
    void displayEventProperties(nEventProperties *pProp);
    void displayEventAttributes(nEventAttributes *pAttributes);

    nSession *m_pSession;
    nSessionAttributes *m_pNsa;

  protected:
    nDataStream *m_pStream;

  private:
    std::string m_lastSessionID;
};

}
}
}
}
