/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */
#include "nLogListener.h"
#include "fSortedList.h"
#include "fBase.h"

#include "Poco/SynchronizedObject.h"
#include "Poco/Runnable.h"

#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nThreadPool;
class nRealmNode;

namespace apps {

using namespace com::pcbsys::foundation::fbase;
using namespace com::pcbsys::foundation::collections;
using namespace Poco;

class ntop : public nLogListener, public Runnable {
  private:
    static ntop *m_pMyself;
    nRealmNode *m_pNode;
    char m_option;
    longlong m_totConsumed;
    longlong m_totPublished;
    int m_refreshRate;
    std::string m_rname;
    longlong m_totMem;
    longlong m_freeMem;
    int m_curCons;
    SynchronizedObject m_change;
    longlong m_prevTime;

    void getRealmNode();
    std::list<nThreadPool*>* getThreadPools();
    void printThreadPools(std::list<nThreadPool*>& threadPools);
    void getLog();
    void printEventsTable();
    void reset();
    void printMemoryUsage();
    void printConnectionStatus();
    void printSpaces(int length);
    void helpMessage();
    void doit();

  public:
    ntop();
    virtual void report(const std::string& rep);
    virtual void run();
    static void main (int argc, char** argv);

  private:
    static void usage();
};

}
}
}
}
}
