#
#   Copyright (c) 1999 - 2011 my-Channels Ltd
#   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
#
#   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
#

from NirvanaModule import *
from Consumer import *

# This is an example of a data stream listener.  Here we register the user as a data stream
# by supplying NirvanaModule.connect with an implementation of NirvanaCallback.
# With data groups, a back end process listens for newly registered groups. That process can
# then add streams to groups (subscribe the user).
class DataStreamListener(Consumer):

    #Override
    def usage(self): 
        print "DataStreamListener <rname> [log level] [count] "
        print ""
        print "<Required Arguments> "
        print ""
        print "<rname> - the rname of the server to connect to"
        print ""
        print "[Optional Arguments]"
        print ""
        print "[log level] - The level of output from each event, 0 - none, 1 - summary, 2 - EIDs, 3 - properties, 4 - All"
        print "[count] - The number of events to wait before printing out summary information : default 10000"

    #Override
    def handleArgs(self, args):
        if (len(args) < 2 ):
            self.usage()
            exit(1)
    
        self.rname = args[1]

        if (len(args) > 2 ):
            self.logLevel = int(args[2])

        if (len(args) > 3 ):
            self.reportCount = int(args[3])

    #Override
    def doit(self):
        self.inputListener.wait()

    #Override
    def establishConnection(self):
        NirvanaModule.connect(self.rname, self) 

    #Override
    def onFinished(self):
        print "Consumed a total of "+str(self.received)


if __name__ == "__main__":
    consumer = DataStreamListener(sys.argv)