#
#   Copyright (c) 1999 - 2011 my-Channels Ltd
#   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
#
#   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
#

from NirvanaModule import *
from datetime import *
import timeit

# This is the base class for the any applications which publish messages.
# It simple defines a few functions which are shared by the other applications.
class Publisher():
    rname = ""
    resourcename = ""
    count = 10
    size = 100

    def usage(self):
        print "Publisher Base Class "
        print ""
        print "This is not a sample application, it provides definitions used by sample apps such as "
        print ""
        print "     ChannelPublisher"
        print "     TXChannelPublisher"
        print "     QueuePublisher"
        print "     TXQueuePublisher"
        print "     DataGroupPublisher"
        print ""

    def handleArgs(self, args):
        print
        #Override me

    def doit(self): 
        print
        #Override me

    def onFinished(self): 
        print
        #Override me

    def __init__(self, args):
        try:
            self.handleArgs(args) #Override me

            NirvanaModule.connect(self.rname)

            timer=timeit.Timer(self.doit)

            timetaken = timer.timeit(1)

            print "Finished, time taken = "+str(timetaken)
            self.onFinished()
            NirvanaModule.shutdown()

        except ValueError as e:
            print ""
            print "***** ValueError ***** : %s" % e
            print ""
            self.usage()
            print ""
            print "***** ValueError ***** : %s" % e

if __name__ == "__main__":
    publisher = Publisher(sys.argv)