#
#   Copyright (c) 1999 - 2011 my-Channels Ltd
#   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
#
#   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
#

from NirvanaModule import *
from Consumer import *

# This is an example of an asynchronous queue consumer. The server will send messages to the client
# as soon as they are published onto the queue. These messages will be process by the onMessage
# method in the implementation of NirvanaCallback
class QueueReader(Consumer):

    #Override
    def usage(self): 
        print "QueueReader <rname> <queue name> [log level] [count] [selector] "
        print ""
        print "<Required Arguments> "
        print ""
        print "<rname> - the rname of the server to connect to"
        print "<queue name> - Queue name parameter for the queue to subscribe to"
        print ""
        print "[Optional Arguments]"
        print ""
        print "[log level] - The level of output from each event, 0 - none, 1 - summary, 2 - EIDs, 3 - All"
        print "[count] - The number of events to wait before printing out summary information : default 10000"
        print "[selector] - The event filter string to use"

    #Override
    def handleArgs(self, args):
        if (len(args) < 2 ):
            self.usage()
            exit(1)

        self.rname = args[1]
        self.resourcename = args[2]

        if (len(args) > 3 ):
            self.logLevel = int(args[3])

        if (len(args) > 4 ):
            self.reportCount = int(args[4])

        if (len(args) > 5 ):
            self.selector = args[5]

    #Override
    def doit(self):
        NirvanaModule.subscribeToQueue(self.resourcename,self, False, 10)
        self.inputListener.wait()

    #Override
    def onFinished(self):
        print "Consumed a total of "+str(self.received)


if __name__ == "__main__":
    consumer = QueueReader(sys.argv)