#
#   Copyright (c) 1999 - 2011 my-Channels Ltd
#   Copyright (c) 2012 - 2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
#
#   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
#

from NirvanaModule import *
from ChannelIterator import *

# This is an example of how to synchronously consume from a queue. Synchronous consumers request
# a message from the server when they are ready to process it.  The implementation of a synchronous
# queue reader is no different from that of a channel iterator so please see the implementation of
# ChannelIterator.
class QueueSyncReader(ChannelIterator):

    #Override
    def usage(self): 
        print ""
        print "QueueSyncReader <rname> <queue name> [log level] [timeout] [count] [selector] "
        print ""
        print "<Required Arguments> "
        print ""
        print "<rname> - the rname of the server to connect to"
        print "<queue name> - Channel/Queue name to connect to"
        print ""
        print "[Optional Arguments]"
        print ""
        print "[log level] - The level of output from each event, 0 - none, 1 - summary, 2 - EIDs, 3 - All"
        print "[timeout] - The timeout for the synchronous call (ms) : default 1000"
        print "[count] - The number of events to wait before printing out summary information : default 10000"
        print "[selector] - The event filter string to use"

#Override
    def handleArgs(self, args):
        if (len(args) < 3 ):
            self.usage()
            exit(1)
    
        self.rname = args[1]
        self.resourcename = args[2]
        self.startEid = -1 #EID is irrelevant for queues

        if (len(args) > 3 ):
            self.logLevel = int(args[3])

        if (len(args) > 4 ):
            self.timeout = int(args[4])

        if (len(args) > 5 ):
            self.reportCount = int(args[5])
    
        if (len(args) > 6 ):
            self.selector = args[6]

if __name__ == "__main__":
    consumer = QueueSyncReader(sys.argv)